diff -ruN ../nakedmudv3.3/src/Makefile src/Makefile
--- ../nakedmudv3.3/src/Makefile	2006-12-24 22:27:44.000000000 -0500
+++ src/Makefile	2007-09-22 23:06:28.000000000 -0400
@@ -26,7 +26,7 @@
 NOCOLOR := \x1B[0m
 
 # the modules we have installed -- mandatory modules go here
-MODULES := char_vars set_val olc2 editor items scripts
+MODULES := dyn_vars set_val olc2 editor items scripts
 
 # optional modules go on this line
 MODULES += time socials alias help
diff -ruN ../nakedmudv3.3/src/SConstruct src/SConstruct
--- ../nakedmudv3.3/src/SConstruct	2006-12-24 23:35:27.000000000 -0500
+++ src/SConstruct	2007-09-22 22:40:41.000000000 -0400
@@ -59,7 +59,7 @@
 binary = 'NakedMud'
 
 # Required modules
-modules = ['char_vars', 'set_val', 'olc2', 'editor', 'items', 'scripts']
+modules = ['dyn_vars', 'set_val', 'olc2', 'editor', 'items', 'scripts']
 
 # Optional modules
 modules += ['time', 'socials', 'alias', 'help']
diff -ruN ../nakedmudv3.3/src/dyn_vars/dyn_vars.c src/dyn_vars/dyn_vars.c
--- ../nakedmudv3.3/src/dyn_vars/dyn_vars.c	1969-12-31 19:00:00.000000000 -0500
+++ src/dyn_vars/dyn_vars.c	2007-09-22 22:44:09.000000000 -0400
@@ -0,0 +1,463 @@
+//*****************************************************************************
+//
+// dyn_vars.c
+//
+// This module allows key/value pairs to be dynamically created on characters,
+// objects, and rooms. Values can be strings, integers, or doubles. If a value
+// is called for in the wrong type (e.g. you're trying to get a string as an 
+// integer) the module will automagically handle the conversion. Variable types
+// default to ints.
+//
+//*****************************************************************************
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../character.h"
+#include "../room.h"
+#include "../object.h"
+#include "../storage.h"
+#include "../auxiliary.h"
+
+#include "dyn_vars.h"
+
+
+
+//*****************************************************************************
+//
+// local functions and datastructurs
+//
+//*****************************************************************************
+
+// used in storage_sets to keep track of what kind of data we're saving
+const char *dyn_var_types[] = {
+  "string",
+  "int",
+  "long",
+  "double"
+};
+
+
+typedef struct dyn_var {
+  char *str_val;
+  int   type;
+} DYN_VAR;
+
+
+DYN_VAR *newDynVarString(const char *str) {
+  DYN_VAR *data = malloc(sizeof(DYN_VAR));
+  data->str_val = strdupsafe(str);
+  data->type    = DYN_VAR_STRING;
+  return data;
+}
+
+DYN_VAR *newDynVarInt(int val) {
+  DYN_VAR  *data = malloc(sizeof(DYN_VAR));
+  char str_val[20]; sprintf(str_val, "%d", val);
+  data->str_val  = strdup(str_val);
+  data->type     = DYN_VAR_INT;
+  return data;
+}
+
+DYN_VAR *newDynVarLong(long val) {
+  DYN_VAR *data = malloc(sizeof(DYN_VAR));
+  char str_val[20]; sprintf(str_val, "%ld", val);
+  data->str_val  = strdup(str_val);
+  data->type     = DYN_VAR_LONG;
+  return data;
+}
+
+DYN_VAR *newDynVarDouble(double val) {
+  DYN_VAR  *data = malloc(sizeof(DYN_VAR));
+  char str_val[20]; sprintf(str_val, "%lf", val);
+  data->str_val  = strdup(str_val);
+  data->type     = DYN_VAR_DOUBLE;
+  return data;
+}
+
+void deleteDynVar(DYN_VAR *data) {
+  if(data->str_val) free(data->str_val);
+  free(data);
+}
+
+DYN_VAR *dynVarCopy(DYN_VAR *data) {
+  DYN_VAR *new_data = malloc(sizeof(DYN_VAR));
+  new_data->str_val = strdup(data->str_val);
+  new_data->type    = data->type;
+  return new_data;
+}
+
+//
+// delete a hashtable of vars
+//
+void deleteDynVarTable(HASHTABLE *table) {
+  HASH_ITERATOR *hash_i = newHashIterator(table);
+  const char       *key = NULL;
+  DYN_VAR          *val = NULL;
+  
+  ITERATE_HASH(key, val, hash_i) {
+    deleteDynVar(val);
+  } deleteHashIterator(hash_i);
+  deleteHashtable(table);
+}
+
+
+
+//*****************************************************************************
+//
+// dyn_var auxiliary data
+//
+//*****************************************************************************
+typedef struct dyn_var_aux_data {
+  HASHTABLE *dyn_vars;
+} DYN_VAR_AUX_DATA;
+
+
+DYN_VAR_AUX_DATA *
+newDynVarAuxData() {
+  DYN_VAR_AUX_DATA *data = malloc(sizeof(DYN_VAR_AUX_DATA));
+  // Hashtables can take up lots of storage space. Because of this, let's
+  // not create any tables until it's actually needed. This will cut down
+  // on lots of memory usage w.r.t. NPCs who do not use character variables
+  //  data->dyn_vars        = newHashtable();
+  data->dyn_vars         = NULL;
+  return data;
+}
+
+
+void
+deleteDynVarAuxData(DYN_VAR_AUX_DATA *data) {
+  if(data->dyn_vars)
+    deleteDynVarTable(data->dyn_vars);
+  free(data);
+}
+
+
+void
+dynVarAuxDataCopyTo(DYN_VAR_AUX_DATA *from, DYN_VAR_AUX_DATA *to) {
+  int from_size = (from->dyn_vars ? hashSize(from->dyn_vars) : 0);
+  int to_size   = (to->dyn_vars   ? hashSize(to->dyn_vars)   : 0);
+
+  // clear out our current data
+  if(to_size > 0) {
+    deleteDynVarTable(to->dyn_vars);
+    to->dyn_vars = NULL;
+  }
+
+  // check to see if the "from" table exists
+  if(from_size > 0) {
+    // make sure the "to" table exists
+    if(to->dyn_vars == NULL)
+      to->dyn_vars = newHashtable();
+
+    // copy everything over
+    HASH_ITERATOR *from_i = newHashIterator(from->dyn_vars);
+    const char       *key = NULL;
+    DYN_VAR         *val = NULL;
+
+    ITERATE_HASH(key, val, from_i)
+      hashPut(to->dyn_vars, key, dynVarCopy(val));
+    deleteHashIterator(from_i);
+  }
+}
+
+
+DYN_VAR_AUX_DATA *
+dynVarAuxDataCopy(DYN_VAR_AUX_DATA *data) {
+  DYN_VAR_AUX_DATA *new_data = newDynVarAuxData();
+  dynVarAuxDataCopyTo(data, new_data);
+  return new_data;
+}
+
+
+STORAGE_SET *dynVarAuxDataStore(DYN_VAR_AUX_DATA *data) {
+  // first, check if the table even exists
+  if(data->dyn_vars == NULL || hashSize(data->dyn_vars) == 0)
+    return new_storage_set();
+
+  STORAGE_SET       *set = new_storage_set();
+  HASH_ITERATOR  *hash_i = newHashIterator(data->dyn_vars);
+  STORAGE_SET_LIST *list = new_storage_list();
+  const char        *key = NULL;
+  DYN_VAR          *val = NULL;
+
+  store_list(set, "variables", list);
+  // iterate across all the entries and add them
+  ITERATE_HASH(key, val, hash_i) {
+    STORAGE_SET *var_set = new_storage_set();
+    store_string(var_set, "key",  key);
+    store_string(var_set, "val",  val->str_val);
+    store_string(var_set, "type", dyn_var_types[val->type]);
+    storage_list_put(list, var_set);
+  }
+  deleteHashIterator(hash_i);
+  return set;
+}
+
+
+HASHTABLE *variableRead(STORAGE_SET *set) {
+  HASHTABLE *table       = newHashtable();
+  STORAGE_SET_LIST *list = read_list(set, "list");
+  STORAGE_SET *var       = NULL;
+
+  while( (var = storage_list_next(list)) != NULL)
+    hashPut(table, read_string(var, "key"), (void *)read_int(var, "val"));
+  return table;
+}
+
+
+DYN_VAR_AUX_DATA *dynVarAuxDataRead(STORAGE_SET *set) {
+  // if the set doesn't contain any entries, don't bother trying to parse
+  if(!storage_contains(set, "variables"))
+    return newDynVarAuxData();
+
+  DYN_VAR_AUX_DATA *data = newDynVarAuxData();
+  STORAGE_SET_LIST  *list = read_list(set, "variables");
+  STORAGE_SET    *var_set = NULL;
+  data->dyn_vars         = newHashtable();
+  
+  while( (var_set = storage_list_next(list)) != NULL) {
+    const char *var_type = read_string(var_set, "type");
+    if(!strcasecmp(var_type, "int"))
+      hashPut(data->dyn_vars, read_string(var_set, "key"),
+	      newDynVarInt(read_int(var_set, "val")));
+    else if(!strcasecmp(var_type, "long"))
+      hashPut(data->dyn_vars, read_string(var_set, "key"),
+	      newDynVarLong(read_long(var_set, "val")));
+    else if(!strcasecmp(var_type, "double"))
+      hashPut(data->dyn_vars, read_string(var_set, "key"),
+	      newDynVarDouble(read_double(var_set, "val")));
+    else if(!strcasecmp(var_type, "string"))
+      hashPut(data->dyn_vars, read_string(var_set, "key"),
+	      newDynVarString(read_string(var_set, "val")));
+    else
+      log_string("ERROR: Tried to read unknown dyn_var type, %s.", var_type);
+  }
+    
+  return data;
+}
+
+
+void init_dyn_vars() {
+  // install dyn vars on the character datastructure
+  auxiliariesInstall("dyn_var_aux_data",
+		     newAuxiliaryFuncs(AUXILIARY_TYPE_CHAR |
+				       AUXILIARY_TYPE_ROOM |
+				       AUXILIARY_TYPE_OBJ,
+				       newDynVarAuxData, deleteDynVarAuxData,
+				       dynVarAuxDataCopyTo, dynVarAuxDataCopy,
+				       dynVarAuxDataStore,dynVarAuxDataRead));
+}
+
+
+
+
+//*****************************************************************************
+//
+// functions for interacting with dyn_vars
+//
+//*****************************************************************************
+int dynGetVarType(DYN_VAR_AUX_DATA *data, const char *key) {
+  DYN_VAR *var = (data->dyn_vars ? hashGet(data->dyn_vars, key) : NULL);
+  return (var ? var->type : DYN_VAR_INT);
+}  
+
+int dynGetInt(DYN_VAR_AUX_DATA *data, const char *key) {
+  DYN_VAR *var = (data->dyn_vars ? hashGet(data->dyn_vars, key) : NULL);
+  return (var ? atoi(var->str_val) : 0);
+}
+
+long dynGetLong(DYN_VAR_AUX_DATA *data, const char *key) {
+  DYN_VAR *var = (data->dyn_vars ? hashGet(data->dyn_vars, key) : NULL);
+  return (var ? atol(var->str_val) : 0);
+}
+
+double dynGetDouble(DYN_VAR_AUX_DATA *data, const char *key) {
+  DYN_VAR *var = (data->dyn_vars ? hashGet(data->dyn_vars, key) : NULL);
+  return (var ? atof(var->str_val) : 0);
+}
+
+const char *dynGetString(DYN_VAR_AUX_DATA *data, const char *key) {
+  DYN_VAR *var = (data->dyn_vars ? hashGet(data->dyn_vars, key) : NULL);
+  return (var ? var->str_val : "");
+}
+
+void dynSetInt(DYN_VAR_AUX_DATA *data, const char *key, int val) {
+  DYN_VAR *old = (data->dyn_vars ? hashRemove(data->dyn_vars, key) : NULL);
+  if(data->dyn_vars == NULL && val != 0)
+    data->dyn_vars = newHashtable();
+  if(old != NULL) 
+    deleteDynVar(old);
+  if(val != 0)
+    hashPut(data->dyn_vars, key, newDynVarInt(val));
+}
+
+void dynSetLong(DYN_VAR_AUX_DATA *data, const char *key, long val) {
+  DYN_VAR *old = (data->dyn_vars ? hashRemove(data->dyn_vars, key) : NULL);
+  if(data->dyn_vars == NULL && val != 0)
+    data->dyn_vars = newHashtable();
+  if(old != NULL) 
+    deleteDynVar(old);
+  if(val != 0)
+    hashPut(data->dyn_vars, key, newDynVarLong(val));
+}
+
+void dynSetDouble(DYN_VAR_AUX_DATA *data, const char *key, double val) {
+  DYN_VAR *old = (data->dyn_vars ? hashRemove(data->dyn_vars, key) : NULL);
+  if(data->dyn_vars == NULL && val != 0)
+    data->dyn_vars = newHashtable();
+  if(old != NULL) 
+    deleteDynVar(old);
+  if(val != 0)
+    hashPut(data->dyn_vars, key, newDynVarDouble(val));
+}
+
+void dynSetString(DYN_VAR_AUX_DATA *data, const char *key, const char *val) {
+  DYN_VAR *old = (data->dyn_vars ? hashRemove(data->dyn_vars, key) : NULL);
+  if(data->dyn_vars == NULL && *val != '\0') 
+    data->dyn_vars = newHashtable();
+  if(old != NULL) 
+    deleteDynVar(old);
+  if(*val != '\0')
+    hashPut(data->dyn_vars, key, newDynVarString(val));
+}
+
+bool dynHasVar(DYN_VAR_AUX_DATA *data, const char *key) {
+  return (data->dyn_vars ? hashIn(data->dyn_vars, key) : FALSE);
+}
+
+void dynDeleteVar(DYN_VAR_AUX_DATA *data, const char *key) {
+  DYN_VAR *var = (data->dyn_vars ? hashRemove(data->dyn_vars, key) : NULL);
+  if(var != NULL) deleteDynVar(var);
+}
+
+int charGetVarType(CHAR_DATA *ch, const char *key) {
+  return dynGetVarType(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+int charGetInt(CHAR_DATA *ch, const char *key) {
+  return dynGetInt(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+long charGetLong(CHAR_DATA *ch, const char *key) {
+  return dynGetLong(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+double charGetDouble(CHAR_DATA *ch, const char *key) {
+  return dynGetDouble(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+const char *charGetString(CHAR_DATA *ch, const char *key) {
+  return dynGetString(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+void charSetInt(CHAR_DATA *ch, const char *key, int val) {
+  dynSetInt(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key, val);
+}
+
+void charSetLong(CHAR_DATA *ch, const char *key, long val) {
+  dynSetLong(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key, val);
+}
+
+void charSetDouble(CHAR_DATA *ch, const char *key, double val) {
+  dynSetDouble(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key, val);
+}
+
+void charSetString(CHAR_DATA *ch, const char *key, const char *val) {
+  dynSetString(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key, val);
+}
+
+bool charHasVar(CHAR_DATA *ch, const char *key) {
+  return dynHasVar(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+void charDeleteVar(CHAR_DATA *ch, const char *key) {
+  dynDeleteVar(charGetAuxiliaryData(ch, "dyn_var_aux_data"), key);
+}
+
+int roomGetVarType(ROOM_DATA *rm, const char *key) {
+  return dynGetVarType(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+int roomGetInt(ROOM_DATA *rm, const char *key) {
+  return dynGetInt(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+long roomGetLong(ROOM_DATA *rm, const char *key) {
+  return dynGetLong(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+double roomGetDouble(ROOM_DATA *rm, const char *key) {
+  return dynGetDouble(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+const char *roomGetString(ROOM_DATA *rm, const char *key) {
+  return dynGetString(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+void roomSetInt(ROOM_DATA *rm, const char *key, int val) {
+  dynSetInt(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key, val);
+}
+
+void roomSetLong(ROOM_DATA *rm, const char *key, long val) {
+  dynSetLong(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key, val);
+}
+
+void roomSetDouble(ROOM_DATA *rm, const char *key, double val) {
+  dynSetDouble(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key, val);
+}
+
+void roomSetString(ROOM_DATA *rm, const char *key, const char *val) {
+  dynSetString(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key, val);
+}
+
+bool roomHasVar(ROOM_DATA *rm, const char *key) {
+  return dynHasVar(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+void roomDeleteVar(ROOM_DATA *rm, const char *key) {
+  dynDeleteVar(roomGetAuxiliaryData(rm, "dyn_var_aux_data"), key);
+}
+
+int objGetVarType(OBJ_DATA *ob, const char *key) {
+  return dynGetVarType(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
+
+int objGetInt(OBJ_DATA *ob, const char *key) {
+  return dynGetInt(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
+
+long objGetLong(OBJ_DATA *ob, const char *key) {
+  return dynGetLong(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
+
+double objGetDouble(OBJ_DATA *ob, const char *key) {
+  return dynGetDouble(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
+
+const char *objGetString(OBJ_DATA *ob, const char *key) {
+  return dynGetString(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
+
+void objSetInt(OBJ_DATA *ob, const char *key, int val) {
+  dynSetInt(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key, val);
+}
+
+void objSetLong(OBJ_DATA *ob, const char *key, long val) {
+  dynSetLong(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key, val);
+}
+
+void objSetDouble(OBJ_DATA *ob, const char *key, double val) {
+  dynSetDouble(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key, val);
+}
+
+void objSetString(OBJ_DATA *ob, const char *key, const char *val) {
+  dynSetString(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key, val);
+}
+
+bool objHasVar(OBJ_DATA *ob, const char *key) {
+  return dynHasVar(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
+
+void objDeleteVar(OBJ_DATA *ob, const char *key) {
+  dynDeleteVar(objGetAuxiliaryData(ob, "dyn_var_aux_data"), key);
+}
diff -ruN ../nakedmudv3.3/src/dyn_vars/dyn_vars.h src/dyn_vars/dyn_vars.h
--- ../nakedmudv3.3/src/dyn_vars/dyn_vars.h	1969-12-31 19:00:00.000000000 -0500
+++ src/dyn_vars/dyn_vars.h	2007-09-22 22:44:09.000000000 -0400
@@ -0,0 +1,71 @@
+#ifndef __DYN_VARS_H
+#define __DYN_VARS_H
+//*****************************************************************************
+//
+// dyn_vars.c
+//
+// This module allows key/value pairs to be dynamically created on characters,
+// objects, and rooms. Values can be strings, integers, or doubles. If a value
+// is called for in the wrong type (e.g. you're trying to get a string as an 
+// integer) the module will automagically handle the conversion. Variable types
+// default to ints.
+//
+//*****************************************************************************
+
+//
+// This must be put at the top of mud.h so the rest of the MUD knows that
+// we've got the alias module installed
+// #define MODULE_DYN_VARS
+//
+
+
+// the different types of data we can store
+#define DYN_VAR_STRING        0
+#define DYN_VAR_INT           1
+#define DYN_VAR_LONG          2
+#define DYN_VAR_DOUBLE        3
+
+
+
+//
+// prepare dyn_vars for use
+//
+void         init_dyn_vars   (void);
+
+int          charGetVarType   (CHAR_DATA *ch, const char *key);
+int          charGetInt       (CHAR_DATA *ch, const char *key);
+long         charGetLong      (CHAR_DATA *ch, const char *key);
+double       charGetDouble    (CHAR_DATA *ch, const char *key);
+const char  *charGetString    (CHAR_DATA *ch, const char *key);
+void         charSetInt       (CHAR_DATA *ch, const char *key, int val);
+void         charSetLong      (CHAR_DATA *ch, const char *key, long val);
+void         charSetDouble    (CHAR_DATA *ch, const char *key, double val);
+void         charSetString    (CHAR_DATA *ch, const char *key, const char *val);
+bool         charHasVar       (CHAR_DATA *ch, const char *key);
+void         charDeleteVar    (CHAR_DATA *ch, const char *key);
+
+int          objGetVarType   (OBJ_DATA *ch, const char *key);
+int          objGetInt       (OBJ_DATA *ch, const char *key);
+long         objGetLong      (OBJ_DATA *ch, const char *key);
+double       objGetDouble    (OBJ_DATA *ch, const char *key);
+const char  *objGetString    (OBJ_DATA *ch, const char *key);
+void         objSetInt       (OBJ_DATA *ch, const char *key, int val);
+void         objSetLong      (OBJ_DATA *ch, const char *key, long val);
+void         objSetDouble    (OBJ_DATA *ch, const char *key, double val);
+void         objSetString    (OBJ_DATA *ch, const char *key, const char *val);
+bool         objHasVar       (OBJ_DATA *ch, const char *key);
+void         objDeleteVar    (OBJ_DATA *ch, const char *key);
+
+int          roomGetVarType   (ROOM_DATA *ch, const char *key);
+int          roomGetInt       (ROOM_DATA *ch, const char *key);
+long         roomGetLong      (ROOM_DATA *ch, const char *key);
+double       roomGetDouble    (ROOM_DATA *ch, const char *key);
+const char  *roomGetString    (ROOM_DATA *ch, const char *key);
+void         roomSetInt       (ROOM_DATA *ch, const char *key, int val);
+void         roomSetLong      (ROOM_DATA *ch, const char *key, long val);
+void         roomSetDouble    (ROOM_DATA *ch, const char *key, double val);
+void         roomSetString    (ROOM_DATA *ch, const char *key, const char *val);
+bool         roomHasVar       (ROOM_DATA *ch, const char *key);
+void         roomDeleteVar    (ROOM_DATA *ch, const char *key);
+
+#endif // __DYN_VARS_H
diff -ruN ../nakedmudv3.3/src/dyn_vars/module.mk src/dyn_vars/module.mk
--- ../nakedmudv3.3/src/dyn_vars/module.mk	1969-12-31 19:00:00.000000000 -0500
+++ src/dyn_vars/module.mk	2007-09-22 22:36:11.000000000 -0400
@@ -0,0 +1,2 @@
+# source files we need to add
+SRC += dyn_vars/dyn_vars.c
diff -ruN ../nakedmudv3.3/src/gameloop.c src/gameloop.c
--- ../nakedmudv3.3/src/gameloop.c	2006-12-24 22:15:56.000000000 -0500
+++ src/gameloop.c	2007-09-22 22:36:11.000000000 -0400
@@ -32,7 +32,7 @@
 // mandatory modules
 //*****************************************************************************
 #include "editor/editor.h"
-#include "char_vars/char_vars.h"
+#include "dyn_vars/dyn_vars.h"
 #include "items/items.h"
 #include "olc2/olc.h"
 #include "set_val/set_val.h"
@@ -214,8 +214,8 @@
   init_editor();
   init_notepad();
 
-  log_string("Initializing character variables.");
-  init_char_vars();
+  log_string("Initializing dynamic variables.");
+  init_dyn_vars();
 
   log_string("Initializing OLC v2.0.");
   init_olc2();
@@ -300,6 +300,12 @@
   /**********************************************************************/
   /*             START THE GAME UP, AND HANDLE ITS SHUTDOWN             */
   /**********************************************************************/
+
+  // Run our initialize hooks. Most C modules will have their own init
+  // functions, but some stuff may need to be set up after *all* modules are
+  // initialized
+  hookRun("initialize", "");
+
   // main game loop
   log_string("Entering game loop");
   game_loop(control);
diff -ruN ../nakedmudv3.3/src/interpret.c src/interpret.c
--- ../nakedmudv3.3/src/interpret.c	2006-12-24 22:15:56.000000000 -0500
+++ src/interpret.c	2007-09-22 22:36:11.000000000 -0400
@@ -115,6 +115,22 @@
     }
   } deleteNearIterator(near_i);
 
+  // do room commands as well
+  if(roomGetCmdTable(charGetRoom(ch)) != NULL) {
+    near_i = newNearIterator(roomGetCmdTable(charGetRoom(ch)));
+    abbrev = NULL;
+    cmd    = NULL;
+    bufferCat(buf, "{c");
+    ITERATE_NEARMAP(abbrev, cmd, near_i) {
+      if(is_keyword(user_groups, cmdGetUserGroup(cmd), FALSE)) {
+	bprintf(buf, "%-13.13s", cmdGetName(cmd));
+	if (!(++col % 6))
+	  bufferCat(buf, "\r\n");
+      }
+    } deleteNearIterator(near_i);
+    bufferCat(buf, "{n");
+  }
+
   // tag on our last newline if neccessary, and show commands
   if (col % 6) bprintf(buf, "\r\n");
   text_to_char(ch, bufferString(buf));
diff -ruN ../nakedmudv3.3/src/items/worn.c src/items/worn.c
--- ../nakedmudv3.3/src/items/worn.c	2006-12-25 19:32:04.000000000 -0500
+++ src/items/worn.c	2007-09-22 22:36:11.000000000 -0400
@@ -339,10 +339,10 @@
 		     "Adds a new worn type to the game.");
   
   // add in our basic worn types
-  //
-  // As of v3.3, worn types can now be added via Python as well as C. People are
-  // encouraged to do so, outside of this module. These are left for historical
-  // purpposes and backwards compatibility with previous version equipment.
+  /*
+    Removed as of v3.3 -- These can now be added via Python with the function,
+    mudsys.add_worn_type(<type>, <position list>)
+
   worn_add_type("shirt",                        "torso");
   worn_add_type("gloves",       "left hand, right hand");
   worn_add_type("left glove",               "left hand");
@@ -350,4 +350,5 @@
   worn_add_type("earrings",                  "ear, ear");
   worn_add_type("earring",                        "ear");
   worn_add_type("ring",                        "finger");
+  */
 }
diff -ruN ../nakedmudv3.3/src/list.c src/list.c
--- ../nakedmudv3.3/src/list.c	2006-12-24 22:15:56.000000000 -0500
+++ src/list.c	2007-09-22 22:36:11.000000000 -0400
@@ -82,6 +82,7 @@
   // go through and kill all of the elements we removed if removes are pending
   if(L->remove_pending) {
     LIST_NODE *node = L->head;
+    L->remove_pending = FALSE;
 
     // while our head is a removed element, 
     // pop it off and delete the list node
diff -ruN ../nakedmudv3.3/src/mud.h src/mud.h
--- ../nakedmudv3.3/src/mud.h	2006-12-24 22:15:56.000000000 -0500
+++ src/mud.h	2007-09-22 22:36:11.000000000 -0400
@@ -23,7 +23,7 @@
 #define MODULE_ITEMS
 #define MODULE_OLC2
 #define MODULE_SCRIPTS
-#define MODULE_CHAR_VARS
+#define MODULE_DYN_VARS
 #define MODULE_SET_VAL
 #define MODULE_EDITOR
 
diff -ruN ../nakedmudv3.3/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv3.3/src/olc2/redit.c	2006-12-24 22:15:56.000000000 -0500
+++ src/olc2/redit.c	2007-09-22 22:36:11.000000000 -0400
@@ -116,17 +116,17 @@
 // functions for printing room reset data
 //*****************************************************************************
 const char *write_reset_arg(int type, const char *arg, const char *locale) {
-  static char buf[SMALL_BUFFER];
-  PROTO_DATA  *obj = 
-    worldGetType(gameworld, "oproto", get_fullkey_relative(arg, locale));
-  PROTO_DATA  *mob = 
-    worldGetType(gameworld, "mproto", get_fullkey_relative(arg, locale));
+  static char buf[MAX_BUFFER];
+  PROTO_DATA  *obj = NULL;
+  PROTO_DATA  *mob = NULL;
   int pos          = atoi(arg);
   switch(type) { 
   case RESET_LOAD_OBJECT:
+    obj = worldGetType(gameworld, "oproto", get_fullkey_relative(arg, locale));
     sprintf(buf, "load %s", (obj ? protoGetKey(obj) : "{RNOTHING{c"));
     break;
   case RESET_LOAD_MOBILE:
+    mob = worldGetType(gameworld, "mproto", get_fullkey_relative(arg, locale));
     sprintf(buf, "load %s", (mob ? protoGetKey(mob) : "{RNOBODY{c"));
     break;
   case RESET_POSITION:
@@ -134,15 +134,19 @@
 	    (pos < 0 || pos >= NUM_POSITIONS ? "{RNOTHING{c":posGetName(pos)));
     break;
   case RESET_FIND_MOBILE:
+    mob = worldGetType(gameworld, "mproto", get_fullkey_relative(arg, locale));
     sprintf(buf, "find %s", (mob ? protoGetKey(mob) : "{RNOBODY{c"));
     break;
   case RESET_FIND_OBJECT:
+    obj = worldGetType(gameworld, "oproto", get_fullkey_relative(arg, locale));
     sprintf(buf, "find %s", (obj ? protoGetKey(obj) : "{RNOTHING{c"));
     break;
   case RESET_PURGE_MOBILE:
+    mob = worldGetType(gameworld, "mproto", get_fullkey_relative(arg, locale));
     sprintf(buf, "purge %s", (mob ? protoGetKey(mob) : "{RNOBODY{c"));
     break;
   case RESET_PURGE_OBJECT:
+    obj = worldGetType(gameworld, "oproto", get_fullkey_relative(arg, locale));
     sprintf(buf, "purge %s", (obj ? protoGetKey(obj) : "{RNOTHING{c"));
     break;
   case RESET_OPEN:
@@ -154,6 +158,9 @@
   case RESET_LOCK:
     sprintf(buf, "close/lock dir %s or container", arg);
     break;
+  case RESET_SCRIPT:
+    sprintf(buf, "run a script on the parent reset");
+    break;
   default:
     sprintf(buf, "UNFINISHED OLC");
     break;
@@ -265,9 +272,15 @@
 		 resetGetChance(data->reset),
 		 resetGetMax(data->reset),
 		 resetGetRoomMax(data->reset),
-		 resetGetArg(data->reset),
+		 (resetGetType(data->reset) != RESET_SCRIPT ? 
+		  resetGetArg(data->reset) : ""),
 		 write_reset(data->reset, 0, FALSE, data->locale)
 		 );
+
+  if(resetGetType(data->reset) == RESET_SCRIPT) {
+    send_to_socket(sock, "\r\n");
+    script_display(sock, resetGetArg(data->reset), FALSE);
+  }
 }
 
 int resedit_chooser(SOCKET_DATA *sock, RESET_OLC *data, const char *option) {
@@ -289,8 +302,14 @@
     text_to_buffer(sock, "What is the max that can exit in room (0 = no limit): ");
     return RESEDIT_ROOM_MAX;
   case '6':
-    text_to_buffer(sock, "What is the reset argument (i.e. obj name, direction, etc...): ");
-    return RESEDIT_ARGUMENT;
+    if(resetGetType(data->reset) == RESET_SCRIPT) {
+      socketStartEditor(sock, script_editor, resetGetArgBuffer(data->reset));
+      return MENU_NOCHOICE;
+    }
+    else {
+      text_to_buffer(sock, "What is the reset argument (i.e. obj name, direction, etc...): ");
+      return RESEDIT_ARGUMENT;
+    }
   case '7':
     do_olc(sock, reslistedit_menu, reslistedit_chooser, reslistedit_parser, 
 	   NULL, NULL, deleteReslistOLC, NULL, 
@@ -781,20 +800,6 @@
       bufferReplace(roomGetDescBuffer(room), "\\\"", "\"", TRUE);
       bufferFormat(roomGetDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
     }
-#ifdef MODULE_TIME
-    else if(!strncmp(lptr, "me.ndesc",  13)) {
-      // we have three "'s to skip by, because this lptr will take the form:
-      // me.desc = me.desc + " " + "..."
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      while(*lptr != '\"') lptr++; lptr++;
-      lptr[strlen(lptr)-1] = '\0'; // kill the ending "
-      roomSetDesc(room, lptr);
-      // replace our \"s with "
-      bufferReplace(roomGetNightDescBuffer(room), "\\\"", "\"", TRUE);
-      bufferFormat(roomGetNightDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
-    }
-#endif
     else if(!strncmp(lptr, "me.terrain", 10)) {
       while(*lptr != '\"') lptr++;
       lptr++;                      // kill the leading "
@@ -923,17 +928,6 @@
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
   }
-#ifdef MODULE_TIME
-  if(*roomGetNightDesc(room)) {
-    BUFFER *desc_copy = bufferCopy(roomGetNightDescBuffer(room));
-    bufferReplace(desc_copy, "\n", " ",    TRUE);
-    bufferReplace(desc_copy, "\r", "",     TRUE);
-    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
-    bprintf(buf, "me.ndesc = me.ndesc + \" \" + \"%s\"\n", 
-	    bufferString(desc_copy));
-    deleteBuffer(desc_copy);
-  }
-#endif
 
   // extra descriptions
   if(listSize(edescSetGetList(roomGetEdescs(room))) > 0) {
@@ -1054,9 +1048,6 @@
 		 "{c%s\r\n"
 		 "{g3) Name\r\n{c%s\r\n"
 		 "{g4) Description\r\n{c%s"
-#ifdef MODULE_TIME
-		 "{g5) Night description (optional)\r\n{c%s"
-#endif
 		 "{gL) Land type {y[{c%s{y]\r\n"
 		 "{gB) Set Bits: {c%s\r\n"
 		 "{gZ) Room can be reset: {c%s\r\n"
@@ -1071,9 +1062,6 @@
 		 roomOLCGetParents(data),
 		 roomGetName(roomOLCGetRoom(data)), 
 		 roomGetDesc(roomOLCGetRoom(data)),
-#ifdef MODULE_TIME
-		 roomGetNightDesc(roomOLCGetRoom(data)),
-#endif
 		 (roomGetTerrain(roomOLCGetRoom(data)) == TERRAIN_NONE ? 
 		  "leave unchanged" :
 		  terrainGetName(roomGetTerrain(roomOLCGetRoom(data)))),
@@ -1105,12 +1093,6 @@
     text_to_buffer(sock, "Enter a new room description:\r\n");
     socketStartEditor(sock, text_editor, roomGetDescBuffer(roomOLCGetRoom(data)));
     return MENU_NOCHOICE;
-#ifdef MODULE_TIME
-  case '5':
-    text_to_buffer(sock, "Enter a new night description:\r\n");
-    socketStartEditor(sock, text_editor, roomGetNightDescBuffer(roomOLCGetRoom(data)));
-    return MENU_NOCHOICE;
-#endif
   case 'Z':
     roomOLCSetResettable(data, (roomOLCGetResettable(data) + 1) % 2);
     return MENU_NOCHOICE;
diff -ruN ../nakedmudv3.3/src/prototype.c src/prototype.c
--- ../nakedmudv3.3/src/prototype.c	2006-12-24 22:15:56.000000000 -0500
+++ src/prototype.c	2007-09-22 22:36:11.000000000 -0400
@@ -205,6 +205,11 @@
     }
   }
 
+  // remove us from the dictionary just incase it doesn't GC immediately. It
+  // happens sometimes if we define a new method in the prototype
+  PyDict_DelItemString(dict, "me");
+  // PyDict_SetItemString(dict, "me", Py_None);
+
   Py_DECREF(dict);
   Py_DECREF(pyme);
   return last_script_ok();
